#!/usr/bin/python 
#
# shuber, 2007-07-07


import copy;
import random



class rubikcube:

		size = None;
		pads = None;


		def __init__ (self, size=3):
				"""Create a rubik cube with specific size"""

				#Save size
				self.size = size;
				#Init every pad with the number of side
				#This is a solved rubik cube btw.
				self.pads = [ [[ side for x in range(size)]
								for y in range(size)]
								for side in range(1,7) ];


		def rotate (self, slice, reverse=False):
				"""Rotate specific slice"""

				def permutate( slice ):
						"""Acutally permutate the pads"""

						dim = slice / self.size
						slnr = slice % self.size

						#Copy old pads
						oldpads = copy.deepcopy(self.pads)
						
						
						#In x direction
						if dim==0:

							#Rotate colomns of faces
							for i in range(self.size):
								self.pads[0][slnr][i] = oldpads[3][slnr][i]
								self.pads[1][slnr][i] = oldpads[0][slnr][i]
								self.pads[2][slnr][i] = oldpads[1][slnr][i]
								self.pads[3][slnr][i] = oldpads[2][slnr][i]

							#Rotate left face
							if slnr==0:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[4][i][j] = oldpads[4][j][self.size-1-i]

							#Rotate right face
							if slnr==self.size-1:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[5][i][j] = oldpads[5][self.size-1-j][i]


						#In y direction
						if dim==1:

							#Rotate colomns of faces
							for i in range(self.size):
								self.pads[4][i][self.size-1-slnr] = oldpads[3][self.size-1-i][slnr]
								self.pads[1][i][self.size-1-slnr] = oldpads[4][i][self.size-1-slnr]
								self.pads[5][i][self.size-1-slnr] = oldpads[1][i][self.size-1-slnr]
								self.pads[3][i][slnr] = oldpads[5][self.size-1-i][self.size-1-slnr]

							#Rotate bottom face
							if slnr==0:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[2][i][j] = oldpads[2][j][self.size-1-i]

							#Rotate top face
							if slnr==self.size-1:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[0][i][j] = oldpads[0][self.size-1-j][i]


						#In z direction
						if dim==2:

							#Rotate colomns of faces
							for i in range(self.size):
								self.pads[0][i][slnr] = oldpads[5][self.size-1-slnr][i]
								self.pads[4][slnr][i] = oldpads[0][self.size-1-i][slnr]
								self.pads[2][i][self.size-1-slnr] = oldpads[4][slnr][i]
								self.pads[5][self.size-1-slnr][i] = oldpads[2][self.size-1-i][self.size-1-slnr]

							#Rotate back face
							if slnr==0:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[3][i][j] = oldpads[3][j][self.size-1-i]

							#Rotate front face
							if slnr==self.size-1:
								for i in range(self.size):
									for j in range(self.size):
										self.pads[1][i][j] = oldpads[1][self.size-1-j][i]


				permutate(slice)

				if reverse:
					permutate(slice)
					permutate(slice)

				




if __name__ == "__main__":

		rubikcube(3);


